---
name: "tor-mac"
suites:
- "precise"
architectures:
- "i386"
packages: 
- "git-core"
- "unzip"
- "zip"
- "autoconf"
- "autoconf2.13"
- "automake"
- "faketime"
- "libtool"
#- "libssl0.9.8"
reference_datetime: "2000-01-01 00:00:00"
remotes:
- "url": "https://git.torproject.org/tor.git"
  "dir": "tor"
- "url": "https://github.com/libevent/libevent.git"
  "dir": "libevent"
- "url": "https://github.com/madler/zlib.git"
  "dir": "zlib"
files:
- "openssl.tar.gz"
- "bug10297.patch"
- "bug5018.patch"
- "apple-uni-sdk-10.6_20110407-0.flosoft1_i386.deb"
- "multiarch-darwin11-cctools127.2-gcc42-5666.3-llvmgcc42-2336.1-Linux-120724.tar.xz"
- "dzip.sh"
#- "apple-x86-gcc_4.2.1~5646.1flosoft2_i386.deb"
#- "apple-x86-odcctools_758.159-0flosoft11_i386.deb"
script: |
  INSTDIR="$HOME/install"
  export LIBRARY_PATH="$INSTDIR/lib"
  export LD_PRELOAD=/usr/lib/faketime/libfaketime.so.1
  export FAKETIME=$REFERENCE_DATETIME
  export TZ=UTC
  export LC_ALL=C
  umask 0022
  #
  #export CFLAGS="-isysroot /usr/lib/apple/SDKs/MacOSX10.6.sdk/"
  #export CXXFLAGS=$CFLAGS
  #export LDFLAGS=$CFLAGS
  export PATH="$PATH:/usr/apple-osx/bin/"
  export CFLAGS="-I/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/include/ -I/usr/lib/gcc/i686-apple-darwin10/4.2.1/include/ -I.  -L/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/lib/ -L/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/lib/system/ -mmacosx-version-min=10.5"
  export LDFLAGS="-L/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/lib/ -L/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/lib/system/ -mmacosx-version-min=10.5"
  #
  mkdir -p $INSTDIR/bin/
  mkdir -p $INSTDIR/TorBrowserBundle.app/Tor/
  mkdir -p $INSTDIR/TorBrowserBundle.app/Data/Tor/
  mkdir -p $OUTDIR/
  #
  sudo dpkg -i *.deb
  cd /usr
  sudo tar -Jxvf /home/ubuntu/build/multiarch-darwin*tar.xz
  cd ~/build
  # For OpenSSL
  sudo ln -s /usr/apple-osx/bin/apple-osx-gcc /usr/apple-osx/bin/i686-apple-darwin11-cc
  #
  #cd zlib
  #find -type f | xargs touch --date="$REFERENCE_DATETIME"
  #make BINARY_PATH=$INSTDIR/zlib/lib INCLUDE_PATH=$INSTDIR/zlib/include LIBRARY_PATH=$INSTDIR/zlib/lib PREFIX=i686-apple-darwin10- $MAKEOPTS SHARED_MODE=1
  #make BINARY_PATH=$INSTDIR/zlib/lib INCLUDE_PATH=$INSTDIR/zlib/include LIBRARY_PATH=$INSTDIR/zlib/lib PREFIX=i686-apple-darwin10- $MAKEOPTS SHARED_MODE=1 install
  #cp $INSTDIR/zlib/lib/*.dylib $INSTDIR/Tor/
  #cd ..
  #
  tar xzf openssl.tar.gz
  cd openssl-*
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  ./Configure --cross-compile-prefix=i686-apple-darwin11- $CFLAGS darwin-i386-cc --prefix=$INSTDIR/openssl #enable-ec_nistp_64_gcc_128
  make # SHARED_LDFLAGS="-shared -dynamiclib -L/usr/lib/apple/SDKs/MacOSX10.6.sdk/usr/lib/"
  make install
  #cp $INSTDIR/openssl/lib/*.dylib $INSTDIR/TorBrowserBundle.app/Tor/
  cd ..
  #
  cd libevent
  ./autogen.sh
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  ./configure --disable-static --host=i686-apple-darwin11 --prefix=$INSTDIR/libevent
  make $MAKEOPTS
  make install
  cp $INSTDIR/libevent/lib/libevent-*.dylib $INSTDIR/TorBrowserBundle.app/Tor/
  LIBEVENT_FILE=`basename $INSTDIR/libevent/lib/libevent-*.dylib`
  cd ..
  #
  cd tor
  git update-index --refresh -q
  export GIT_COMMITTER_NAME="nobody"
  export GIT_COMMITTER_EMAIL="nobody@localhost"
  export GIT_COMMITTER_DATE="$REFERENCE_DATETIME"
  git am ~/build/bug10297.patch
  git am ~/build/bug5018.patch
  mkdir -p $OUTDIR/src
  git archive HEAD | tar -x -C $OUTDIR/src
  ./autogen.sh
  find -type f | xargs touch --date="$REFERENCE_DATETIME"
  ./configure --enable-static-openssl --disable-asciidoc --host=i686-apple-darwin11 --with-libevent-dir=$INSTDIR/libevent --with-openssl-dir=$INSTDIR/openssl --prefix=$INSTDIR --with-zlib-dir=$INSTDIR/zlib/
  make $MAKEOPTS
  make install
  cd ..
  cp $INSTDIR/bin/tor $INSTDIR/TorBrowserBundle.app/Tor/
  cp $INSTDIR/share/tor/geoip $INSTDIR/TorBrowserBundle.app/Data/Tor/
  cd $INSTDIR/TorBrowserBundle.app/Tor/
  i686-apple-darwin11-install_name_tool -change /home/ubuntu/install/libevent/lib/$LIBEVENT_FILE @executable_path/$LIBEVENT_FILE tor
  # XXX: Geoip files..
  #
  #cp -a /usr/lib/gcc/i686-apple-darwin10/4.6/libgcc_s_sjlj-1.dll $INSTDIR/Tor/
  #cp -a /usr/lib/gcc/i686-apple-darwin10/4.6/libssp*.dll $INSTDIR/Tor/
  #
  cd $INSTDIR
  ~/build/dzip.sh tor-mac$GBUILD_BITS-gbuilt.zip TorBrowserBundle.app
  cp tor-mac$GBUILD_BITS-gbuilt.zip $OUTDIR/
